%% function for create graph with specified distribution
function Graph=SetDistribGraph(ro,a,expmu,sigma,MaxDeg,Rad,Len)
% close all;
tic
Len=Rad*25;
% t1=tic;
Volume=pi*Rad^2*Len;
Nr=round(Volume*ro);
% N=round(2*Nr/d);
% if mod(N,2)
%     N=N+1;
% end

NumIntLen=round(log2(Nr))+1;
xmax=sqrt(Len^2+4*Rad^2);
IntLen=xmax/NumIntLen;
x=IntLen/2:IntLen:xmax-IntLen/2;
y=lognpdf(x,log(expmu),sigma);
y=y/sum(y);
% y=y*(x(2)-x(1));

VectLen=x;
RaspLen=y;
RaspLen=round(RaspLen*Nr);

VectEd=0:MaxDeg;
RaspEd=VectEd.^-a;
RaspEd([1,2,3])=0;
if RaspEd(4)==0
    RaspEd(4)=1;
end
RaspEd=RaspEd/sum(RaspEd);
% figure
% plot(VectEd,RaspEd)


koef=sum(VectEd/2.*RaspEd);

N=round(Nr/koef);
RaspEd=round(RaspEd*N);
RaspEd(4)=Nr;

%% generate random coordinates of nodes
coord1=rand(1,N)*Len;
ang=rand(1,N)*2*pi;
rad=rand(1,N)*Rad;
coord2=Rad+real(rad.*exp(1j*ang));
coord3=Rad+imag(rad.*exp(1j*ang));

% Rx=max(coord1);
% Ry=max(coord2);
% Rz=max(coord3);

%% first part of table - coordinates of nodes
T1=[cell(1,0),'nodes'];
for i=1:N
    T1=[T1;[num2str(i),' x =   ',num2str(coord1(i)),'     y =    ',num2str(coord2(i)),'     z =    ',num2str(coord3(i))]];
end

%% create 3D plot
% if N<=1000
%     figure
%     hold on
%     for i=1:N
%         plot3(coord1(i),coord2(i),coord3(i),'o')
%     end
%     axis equal
% end

TabEd=zeros(N,1);
TabLen=inf(N,N);
TabLink=zeros(N,N);

% 	  TabLen  N  N,      () 
kk=0;
for i=1:N-1
    for j=i+1:N
        TabLen(i,j)=sqrt((coord1(i)-coord1(j))^2+(coord2(i)-coord2(j))^2+(coord3(i)-coord3(j))^2);
        kk=kk+1;
%         if i==j
%             TabLen(i,j)=inf;
%         end
    alllen(kk)=TabLen(i,j);
    end
end
% TabLen(triu)


% toc(t1)
[~,LenLim]=min(abs(VectLen-Len/3));
h=waitbar(0);
IsNodeNotFull2=true(N,1);
TabLen22=zeros(N,N);
NowRaspEd=[];

%      VectLen       TabLen,  ,          RaspEd       ,    ,   ,    .
for i=NumIntLen:-1:1%variant1
% for i=1:NumIntLen%variant2
    for j=1:RaspLen(i)

        [val,rows]=min(abs(TabLen+TabLen22-VectLen(i)),[],1);
        [~,indrow]=min(val);
        row=rows(indrow);
%         [val,cols]=min(abs(TabLen-VectLen(i)),[],2);
        [val,cols]=min(abs(TabLen+TabLen22-VectLen(i)),[],2);
        [~,indcol]=min(val);

        col=cols(indcol);
        TabLink(row,col)=1;
        TabLink(col,row)=1;
%         if row==1&col==1
%             1
%         end
        TabEd(col)=TabEd(col)+1;
        TabLen(col,row)=inf;
        TabLen(row,col)=inf;
%         try
        TabEd(row)=TabEd(row)+1;
        
        NowRaspEd=[];
        for k=0:MaxDeg
            NowRaspEd(k+1)=sum(TabEd==k);
        end
        

            for k=1:N
                if TabEd(k)+1+1<MaxDeg
                    IsNodeNotFull2(k)=sum(NowRaspEd(TabEd(k)+1+1:end))<sum(RaspEd(TabEd(k)+1+1:end));%&sum(NowRaspEd(TabEd(l)+1+1:end))<sum(RaspEd(TabEd(l)+1+1:end));
                else
                    IsNodeNotFull2(k)=false;
                end
                if ~IsNodeNotFull2(k)
                    TabLen22(k,:)=inf(1,N);
                    TabLen22(:,k)=inf(N,1);
                end
            end

         trr=sum(sum(TabLink))/Nr/2;
%         toc(t5)
%         t6=tic;
        ioo=mod(round(trr*1000),100)==0;
%         toc(t6)
%         t7=tic;        
        if ioo
        waitbar(trr,h)
        pause(1)
        end
%         toc(t7)
    end
end
close(h)

    G =TabLink;
    G=triu(G,1);
    [first,last]=find(G);
    T2=[first,last];%   T2        .
        
all=[coord1',coord2',coord3'];
Graph.nd=all;
Graph.ed=T2;
Graph.RL=[Rad,Len];
Graph.ni=NumIntLen;
Graph.vr=[ro,a,expmu,sigma,NumIntLen,MaxDeg,Rad,Len];

DateString=datestr(clock);
DateString(DateString==':')='_';
DateString(end-8:end)=[];
DateString=[num2str(ro),'_',num2str(a),'_',num2str(expmu),'_',num2str(sigma),'_',num2str(MaxDeg),'_',num2str(Rad),'_',num2str(Len)];
Graph.String=DateString;
save([DateString,'.mat'],'Graph');
toc
% (ro,a,expmu,sigma,MaxDeg,Rad,Len)


